;;; -*- mode: Emacs-Lisp; coding: euc-jp; -*-
;;; $Id: elisp-info.el,v 2.11 2001/02/14 07:21:35 tsuchiya Exp $

;; Copyright (C) 1998,1999,2000,2001
;;     TSUCHIYA Masatoshi <tsuchiya@pine.kuee.kyoto-u.ac.jp>

;; Author: TSUCHIYA Masatoshi <tsuchiya@pine.kuee.kyoto-u.ac.jp>
;; Keywords: emacs lisp info

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 2, or (at
;; your option) any later version.

;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.


;;; Commentary:

;; Emacs-Lisp Υץ񤤤ƤEmacs-Lisp Reference Manual 
;; ˤ˻ȤΤǤ٤ Info ˰ܤäƸΤݤ
;; ʤäΤǡѿ̾ؿ̾ꤹ Info γʬɽƤ
;; 륳ޥɤޤ
;;
;; describe-function  describe-variable ɤư򤷤ޤ
;; ꤵ줿ؿ(ѿ) Reference Manual ǲ⤵Ƥ
;; ϡʸɽ Info γʬ˥פޤ
;;
;; 켡۸
;;     http://www-nagao.kuee.kyoto-u.ac.jp/member/tsuchiya/elisp/index.html
;;     http://www-nagao.kuee.kyoto-u.ac.jp/member/tsuchiya/elisp/elisp-info.el


;;; Warning:

;; ®ŪȤƺեηѹޤΤǡǤ
;; ƤϡM-x elisp-info-make-index Ƽ¹Ԥơե
;; ĤľƲ


;;; Install:

;; (1) ܸ Emacs-Lisp Reference Manual Ǥ褦ˤƲ
;;     Texinfo Υեϡ
;;
;;         Emacs19 б
;;             ftp://etlport.etl.go.jp/pub/mule/elisp-manual-19-2.4-jp2.0.tar.gz
;;
;;         Emacs20 б
;;             ftp://ftp.ascii.co.jp/pub/GNU/elisp-manual-20-2.5-jp.tgz
;;
;;     ʤɤǽǤ
;;
;; (2) elisp-info.el Ŭʥǥ쥯ȥ˥ԡƲ
;;
;; (3) elisp-info-index.el 뤿ˡM-x elisp-info-make-index
;;     Ȥ뤫Υޥɤ¹ԤƲ
;;
;;         mule -batch -l ~/.emacs -l ./elisp-info.el -f elisp-info-make-index
;;
;;     ǥեȤǤ Emacs-Lisp Reference Manual  Mule-jp оݤ
;;     Ƹޤפ Info 䡤оݤȤʤ Info 
;;     äϡelisp-info-list ѹƲ
;;
;; (4) λ ~/.emacs ˲äƲ
;;
;; (require 'elisp-info)
;; (eval-after-load "help.el"
;;                  (progn
;;                    (define-key help-map "f" 'elisp-info-describe-function)
;;                    (define-key help-map "d" 'elisp-info-describe-function)
;;                    (define-key help-map "D" 'describe-function)
;;                    (define-key help-map "v" 'elisp-info-describe-variable)
;;                    (define-key help-map "V" 'describe-variable)
;;                    (define-key help-mode-map "i" 'elisp-info-help-to-info)))
;;
;;     Τ褦˻ꤹ C-h f  C-h v ˳ƤƤ 
;;     describe-function  describe-variable 򿷤ޥɤ֤
;;     ޤ
;;
;; Info ɽΤˡɽְ֤äƤϡؿ(
;; )̾ Node бطϿƤ elisp-info-index.el 
;; ľɬפΤǡM-x elisp-info-make-index Ƽ¹ԤƲ


;;; ¸ط

(provide 'elisp-info)
(eval-when-compile
  (require 'info)
  (condition-case nil (require 'font-lock) (error nil))
  (condition-case nil (require 'custom) (error nil))
  (condition-case nil (require 'advice) (error nil))
  (or (fboundp 'defgroup)
      (defmacro defgroup (symbol members doc &rest args) nil))
  (or (fboundp 'defcustom)
      (defmacro defcustom (symbol value doc &rest args)
	(` (defvar (, symbol) (, value) (, doc)))))
  (or (fboundp 'defface)
      (defmacro defface (face spec doc &rest args) nil))
  (or (fboundp 'defadvice)
      (defmacro defadvice (function args &rest body) nil)))


;;; ѿ/

(defgroup elisp-info nil
  "Various sorts of improved help system for Emacs-Lisp."
  :group 'help
  :group 'docs)

(defcustom elisp-info-list
  '("elisp-jp" "mule-jp")
  "򸡺 Info Υꥹ"
  :group 'elisp-info
  :type '(repeat string))

(defcustom elisp-info-split-window t
  "Non-nil means window will be split vertically to display descriptions."
  :group 'elisp-info
  :type 'boolean)

(defcustom elisp-info-select-window nil
  "Non-nil means window will be selected when display descriptions."
  :group 'elisp-info
  :type 'boolean)

(defcustom elisp-info-add-info-button
  (fboundp 'help-xref-button)
  "Non-nil means buttons link to appropriate node are added."
  :group 'elisp-info
  :type 'boolean
  :set (lambda (symbol value)
 	 (set-default symbol value)
	 (elisp-info-setup-advices))
  :initialize 'custom-initialize-default)

(defcustom elisp-info-use-advised-info
  (and (featurep 'advice)
       (fboundp 'find-function)
       (fboundp 'find-variable))
  "Non-nil means advices of Info-mode are enabled."
  :group 'elisp-info
  :type 'boolean
  :set (lambda (symbol value)
 	 (set-default symbol value)
	 (elisp-info-setup-advices))
  :initialize 'custom-initialize-default)

(defcustom elisp-info-use-font-lock
  (and (featurep 'font-lock)
       (if (featurep 'xemacs)
	   (and (boundp 'font-lock-auto-fontify)
		font-lock-auto-fontify)
	 (and (boundp 'global-font-lock-mode)
	      global-font-lock-mode)))
  "Non-nil means advice to fontify info buffer is enabled."
  :group 'elisp-info
  :type 'boolean
  :set (lambda (symbol value)
 	 (set-default symbol value)
	 (elisp-info-setup-advices))
  :initialize 'custom-initialize-default)

(defun elisp-info-get-index-file (identifier)
  "եõؿ"
  (let ((src (format "%s.el" identifier))
	(index (format "%s-index.el" identifier)))
    (catch 'found
      (mapcar
       (lambda (file)
	 (mapcar
	  (lambda (dir)
	    (if (file-exists-p (expand-file-name file dir))
		(throw 'found (expand-file-name index dir))))
	  load-path))
       (list index src))
      nil)))

(defcustom elisp-info-index-file
  (elisp-info-get-index-file "elisp-info")
  "Info ǲ⤵Ƥؿѿκե"
  :group 'elisp-info
  :type 'file)

(defvar elisp-info-function-alist nil
  "Info ǲ⤵ƤؿϢ")

(defcustom elisp-info-missing-function-alist nil
  "ʬưŪ˼ФʤäؿϢ"
  :group 'elisp-info
  :type '(repeat (list
		  (symbol :tag "Function")
		  (string :tag "Node")
		  (integer :tag "Line Number")))
  :set (lambda (symbol value)
	 (set-default symbol value)
	 (setq elisp-info-function-alist
	       (append value elisp-info-function-alist)))
  :initialize 'custom-initialize-default)

(defvar elisp-info-variable-alist nil
  "Info ǲ⤵ƤѿϢ")

(defcustom elisp-info-missing-variable-alist nil
  "ʬưŪ˼ФʤäѿϢ"
  :group 'elisp-info
  :type '(repeat (list
		  (symbol :tag "Variable")
		  (string :tag "Node")
		  (integer :tag "Line Number")))
  :set (lambda (symbol value)
	 (set-default symbol value)
	 (setq elisp-info-variable-alist
	       (append value elisp-info-variable-alist)))
  :initialize 'custom-initialize-default)

(defface elisp-info-font-lock-entry-face
  '((((class color) (background dark)) (:foreground "cyan"))
    (((class color) (background light)) (:foreground "blue")))
  "Used to fontify entries."
  :group 'info)

(defface elisp-info-font-lock-entry-body-face
  '((((class color) (background dark)) (:foreground "cyan" :bold t))
    (((class color) (background light)) (:foreground "blue" :bold t))
    (t (:bold t)))
  "Used to fontify entries."
  :group 'info)

(defface elisp-info-font-lock-xref-face
  '((((class color) (background dark)) (:foreground "Plum1"))
    (((class color) (background light)) (:foreground "purple")))
  "Used to fontify cross references."
  :group 'info)

(defface elisp-info-font-lock-xref-body-face
  '((((class color) (background dark)) (:foreground "Plum1" :bold t))
    (((class color) (background light)) (:foreground "purple" :bold t))
    (t (:italic t)))
  "Used to fontify cross references."
  :group 'info)

(defface elisp-info-font-lock-keyword-face
  '((((class color) (background dark)) (:foreground "yellow"))
    (((class color) (background light)) (:foreground "firebrick" :underline t))
    (t (:underline t)))
  "Used to fontify keywords."
  :group 'info)

(defvar elisp-info-font-lock-keywords
  (eval-when-compile
    (if (fboundp 'font-lock-compile-keywords)
	(font-lock-compile-keywords
	 '(("^\\(\\* \\)\\([^:]+:+\\)"
	    (1 'elisp-info-font-lock-entry-face t)
	    (2 'elisp-info-font-lock-entry-body-face t))
	   ("^\\* Menu:$" 0 'elisp-info-font-lock-entry-face t)
	   ("\\(\\*[Nn]ote\\b\\)\\([^:]+:+\\)"
	    (1 'elisp-info-font-lock-xref-face t)
	    (2 'elisp-info-font-lock-xref-body-face t))
	   ;; ɽϰʲñ˰פ
	   ;;     Prefix Command, Command, Data Type, Deprecated Function,
	   ;;     Obsolete Function, POSIX.1 Function, BSD Function,
	   ;;     System V Function, Function, Global Variable, Local Variable,
	   ;;     Variable, Macro, Method, Special Form, User Option,
	   ;;     Option, ץեåޥ, ޥ.
	   ("^[ ^\t]-+[ \t]+\\(\\([Pp]refix[ \t]+\\)?[Cc]ommand\\|[Dd]ata[ \t]+[Tt]ype\\|\
\\(\\(Deprecated\\|Obsolete\\|POSIX\\.1\\|BSD\\|System[ \t]+V\\)[ \t]+\\)?[Ff]unction\\|\
\\(\\([Gg]lob\\|[Ll]oc\\)al[ \t]+\\)?[Vv]ariable\\|[Mm]\\(acro\\|ethod\\)\
\\|[Ss]pecial[ \t]+[Ff]orm\\|\\([Uu]ser[ \t]+\\)?[Oo]ption\\|\\(ץեå\\)?ޥ\\):.*$"
	    0 'elisp-info-font-lock-keyword-face t)))))
  "Rules for highlighting Info pages.")

(defconst elisp-info-node-regexp "\^_\nFile: %s, +Node: +\\([^,\n\t]+\\)[,\n\t]"
  "Info γ Node Ƭ˹פɽ")

(defconst elisp-info-entry-regexp "\
^[ \t]+-+[ \t]+\\(\\(Prefix[ \t]+\\)?Command\\|\\(ץեå\\)?ޥ\\|\
Function\\|Special[ \t]+Form\\|Macro\\|\\(\\(Glob\\|Loc\\)al[ \t]+\\)?Variable\\|\
\\(User[ \t]+\\)?Option\\):[ \t]+\\([^ \t\n]+\\)[ \t\n]"
  "ؿ/ѿβƬʬ˹פɽ")

(defconst elisp-info-entry-regexp-pos 7
  "ؿ/ѿβƬʬ˹פɽδؿ̾/ѿ̾ΰ")

(defconst elisp-info-variable-regexp "\\(Variable\\|Option\\)"
  "Ф줿⤬ѿˤĤƤβǤ˰פɽ")

(defconst elisp-info-index-regexp
  "^\\* +\\([^\n:]*:*\\):[ \t]*\\([^.\n]*\\)\\.[ \t]*\\([0-9]*\\)"
  "ؿ/ѿκϤ뤿ɽ")

(defconst elisp-info-index-suffix-regexp
  "[ \t]*<[0-9]+>$"
  "ܤνʣ򤱤뤿Ϳ˰פɽ")

(defconst elisp-info-buffer-name "*elisp info*"
  "ؿ/ѿβɽ뤿˻ѤХåե̾")

(defconst elisp-info-identifier "Emacs Lisp"
  "Хåե̤뤿˥⡼ɹԤɽʸ")

(defvar elisp-info/buffer-local-identifier nil)
(defvar elisp-info/described-function nil)
(defvar elisp-info/described-variable nil)

(defconst elisp-info/advice-alist
  '((elisp-info-add-info-button
     after
     ((describe-function .	elisp-info-function-add-info-button)
      (describe-key .		elisp-info-key-add-info-button)
      (describe-variable .	elisp-info-variable-add-info-button)))
    (elisp-info-use-advised-info
     around
     ((Info-next-reference .	elisp-info-next-reference)
      (Info-prev-reference .	elisp-info-prev-reference)
      (Info-follow-nearest-node . elisp-info-follow-nearest-node)
      (Info-follow-reference .	elisp-info-follow-reference)
      (Info-set-mode-line .	elisp-info-set-mode-line)))
    (elisp-info-use-font-lock
     around
     ((Info-fontify-node .	elisp-info-fontify-node)))))



;;;------------------------------------------------------------
;;;	ؿ/ѿʸɽؿ
;;;------------------------------------------------------------

(defsubst elisp-info/load-index-file ()
  (or (featurep 'elisp-info-index)
      (progn
	(load elisp-info-index-file t)
	(or (and (symbolp (car (car elisp-info-function-alist)))
		 (symbolp (car (car elisp-info-variable-alist))))
	    (error "Please rebuild index file (%s)."
		   elisp-info-index-file))
	(setq elisp-info-function-alist
	      (append elisp-info-missing-function-alist
		      elisp-info-function-alist)
	      elisp-info-variable-alist
	      (append elisp-info-missing-variable-alist
		      elisp-info-variable-alist)))))


(put 'elisp-info/static-if 'lisp-indent-function 2)
(defmacro elisp-info/static-if (cond then &rest else)
  (if (eval cond) then (` (progn  (,@ else)))))


;;;###autoload
(defun elisp-info-describe-function (function)
  "Display the info node or the full documentation of FUNCTION (a symbol)."
  (interactive
   (let ((enable-recursive-minibuffers t)
	 (fn (function-called-at-point))
	 val)
     (setq val (completing-read
		(if fn
		    (format "Show info or describe function (default %s): " fn)
		  "Show info or describe function: ")
		obarray 'fboundp t))
     (list (if (equal val "") fn (intern val)))))
  (elisp-info/load-index-file)
  (let ((entry (assq function elisp-info-function-alist)))
    (if entry
	(elisp-info-goto-entry entry
			       elisp-info-buffer-name
			       elisp-info-identifier)
      (describe-function function)
      (save-window-excursion
	(save-excursion
	  (other-window 1)
	  (set-buffer (window-buffer (selected-window)))
	  (push-mark (point-min) t t))))))


(defun elisp-info/make-button (node function arg)
  (if node
      (let (buffer-read-only)
	(save-excursion
	  (save-match-data
	    (goto-char (point-max))
	    (or (bolp) (insert "\n"))
	    (set-match-data
	     (list
	      (point-marker)
	      (progn
		(insert "["
			(if (string-match "(\\([^)]*\\))" node)
			    (match-string 1 node)
			  node)
			"]")
		(point-marker))))
	    (help-xref-button 0 function arg))))))


(defadvice describe-function
  (after elisp-info-function-add-info-button disable)
  (with-current-buffer "*Help*"
    (set (make-local-variable 'elisp-info/described-function) (ad-get-arg 0))
    (set (make-local-variable 'elisp-info/described-variable) nil)
    (elisp-info/load-index-file)
    (elisp-info/make-button
     (nth 1 (assq (ad-get-arg 0) elisp-info-function-alist))
     'elisp-info-describe-function
     (ad-get-arg 0))))


(defadvice describe-key
  (after elisp-info-key-add-info-button disable)
  (let ((func (key-binding (ad-get-arg 0))))
    (with-current-buffer "*Help*"
      (or
       (null func)
       (integerp func)
       (progn
	 (set (make-local-variable 'elisp-info/described-function) func)
	 (set (make-local-variable 'elisp-info/described-variable) nil)
	 (elisp-info/load-index-file)
	 (elisp-info/make-button
	  (nth 1 (assq func elisp-info-function-alist))
	  'elisp-info-describe-function
	  func))))))


;;;###autoload
(defun elisp-info-describe-variable (variable)
  "Display the info node or the full documentation of VARIABLE (a symbol)."
  (interactive
   (let ((enable-recursive-minibuffers t)
	 (v (variable-at-point))
	 val)
     (setq val (completing-read
		(if v
		    (format "Show info or describe variable (default %s): " v)
		  "Show info describe variable: ")
		obarray 'boundp t))
     (list (if (equal val "") v (intern val)))))
  (elisp-info/load-index-file)
  (let ((entry (assq variable elisp-info-variable-alist))
	(value (symbol-value variable)))
    (if entry
	(progn
	  (elisp-info-goto-entry entry
				 elisp-info-buffer-name
				 elisp-info-identifier)
	  (message "%s's value is %s"
		   (symbol-name variable) (prin1-to-string value)))
      (describe-variable variable)
      (save-window-excursion
	(save-excursion
	  (other-window 1)
	  (set-buffer (window-buffer (selected-window)))
	  (push-mark (point-min) t t))))))


(defadvice describe-variable
  (after elisp-info-variable-add-info-button disable)
  (with-current-buffer "*Help*"
    (set (make-local-variable 'elisp-info/described-function) nil)
    (set (make-local-variable 'elisp-info/described-variable) (ad-get-arg 0))
    (elisp-info/load-index-file)
    (elisp-info/make-button
     (nth 1 (assq (ad-get-arg 0) elisp-info-variable-alist))
     'elisp-info-describe-variable
     (ad-get-arg 0))))


;;;###autoload
(defun elisp-info-help-to-info ()
  "View Info if entry exist."
  (interactive)
  (elisp-info/load-index-file)
  (let ((entry
	 (or
	  (and elisp-info/described-function
	       (assq elisp-info/described-function
		     elisp-info-function-alist))
	  (and elisp-info/described-variable
	       (assq elisp-info/described-variable
		     elisp-info-variable-alist)))))
    (if entry
	(elisp-info-goto-entry entry
			       elisp-info-buffer-name
			       elisp-info-identifier)
      (message (format "Can't find node for `%s'."
		       (prin1-to-string
			(or elisp-info/described-function
			    elisp-info/described-variable)))))))


(put 'elisp-info/split-window 'edebug-form-spec '(body))
(defmacro elisp-info/split-window (&rest body)
  (let ((orig-buffer (make-symbol "orig-buffer"))
	(orig-start (make-symbol "orig-start"))
	(orig-point (make-symbol "orig-point"))
	(tmpvar (make-symbol "return-value")))
    (` (let (((, orig-buffer) (current-buffer))
	     ((, orig-start) (window-start))
	     ((, orig-point) (point))
	     ((, tmpvar)))
	 ;; prog1 ȤȤͤEmacs20 Ǥ window-configuration
	 ;; Ƥޤᡤտ̤ưʤ
	 (setq (, tmpvar) (progn (,@ body)))
	 (let ((window (selected-window))
	       (buffer (current-buffer))
	       (point (point))
	       (visible))
	   (or (eq buffer (, orig-buffer))
	       (if elisp-info-split-window
		   (progn
		     (set-window-buffer window (, orig-buffer))
		     (set-window-start window (, orig-start))
		     (if (one-window-p)
			 (or (setq visible (get-buffer-window buffer))
			     (split-window)))
		     (goto-char (, orig-point))
		     (or (pos-visible-in-window-p (, orig-point) window)
			 (recenter
			  (elisp-info/static-if
			      (and (boundp 'emacs-major-version)
				   (>= emacs-major-version 20))
			      (if (> (, orig-point) (window-end window t)) -3 2)
			    (/ (window-height) 2)))))))
	   (if (or visible (setq visible (get-buffer-window buffer)))
	       (select-window visible)
	     (if elisp-info-split-window
		 (select-window (next-window)))
	     (set-window-buffer (selected-window) buffer))
	   (goto-char point)
	   (recenter 2)
	   (or elisp-info-select-window
	       (select-window window)))
	 (, tmpvar)))))


(defsubst elisp-info/show-entry (entry &optional interactive-select)
  (if (<= (length entry) 3)
      (progn
	(Info-goto-node (nth 1 entry))
	(goto-char (point-min))
	(forward-line (nth 2 entry)))
    (setq Info-index-alternatives
	  (let ((node (cdr entry)) (alt))
	    (while node
	      (setq alt (cons (list
			       (if (symbolp (car entry))
				   (symbol-name (car entry))
				 (car entry))
			       (car node)
			       (car node)
			       (car (cdr node)))
			      alt)
		    node (cdr (cdr node))))
	    (nreverse alt)))
    (if interactive-select
	(let* ((completion-ignore-case t)
	       (table (mapcar
		       (lambda (e)
			 (cons (if (string-match "(\\([^)]*\\))" (nth 1 e))
				   (substring (nth 1 e) (match-end 0))
				 (nth 1 e))
			       e))
		       Info-index-alternatives))
	       (top (cdr (assoc
			  (completing-read "node: " table nil t nil nil)
			  table))))
	  (setq Info-index-alternatives
		(cons top
		      (delq top Info-index-alternatives)))))
    (Info-index-next 0)))


;;;###autoload
(defun elisp-info-goto-entry
  (entry &optional buffer-name identifier interactive-select)
  "Function to show info entry."
  (elisp-info/split-window
   (require 'info)
   ;; Mule-2.3@19.34  Emacs20 Ǥ Info-goto-node ưۤʤäƤ
   ;; 뤿ᡤbuffer-name ꤷơ̾ Info ̤ΥХåեǴؿ
   ;; /ѿʸ뤳ȤϤǤʤ
   (elisp-info/static-if
       (and (boundp 'emacs-major-version) (>= emacs-major-version 20))
       (if buffer-name
	   (progn
	     (set-buffer (get-buffer-create buffer-name))
	     (or (eq major-mode 'Info-mode) (Info-mode))
	     (set (make-local-variable 'elisp-info/buffer-local-identifier) identifier)
	     (elisp-info/show-entry entry interactive-select))
	 (info)
	 (elisp-info/show-entry entry interactive-select))
     (info)
     (elisp-info/show-entry entry interactive-select))
   (push-mark (point) t t)
   t)) ; return value


;;;###autoload
(defun elisp-info-goto-node (node line &optional buffer-name identifier)
  "Function to show info."
  (elisp-info-goto-entry (list nil node line) buffer-name identifier))



;;;------------------------------------------------------------
;;;	Info ĥ
;;;------------------------------------------------------------

(defsubst elisp-info/active-p ()
  (and (boundp 'Info-current-file)
       (stringp Info-current-file)
       (member (file-name-nondirectory Info-current-file)
	       elisp-info-list)))


(defsubst elisp-info/search-next-reference (start end)
  (goto-char start)
  (and (re-search-forward elisp-info-entry-regexp end t)
       (goto-char (match-beginning elisp-info-entry-regexp-pos))))


(defadvice Info-next-reference
  (around elisp-info-next-reference disable)
  (if (elisp-info/active-p)
      (let ((start (point)))
	(condition-case err
	    (let (end)
	      ad-do-it
	      (setq end (point))
	      (goto-char
	       (or (if (< start end)
		       (elisp-info/search-next-reference start end)
		     (or (elisp-info/search-next-reference start (point-max))
			 (elisp-info/search-next-reference (point-min) end)))
		   end)))
	  (error
	   (if (string= (error-message-string err)
			"No cross references in this node")
	       (goto-char
		(or (elisp-info/search-next-reference start (point-max))
		    (elisp-info/search-next-reference (point-min) start)
		    start)))
	   (if (eq (point) start)
	       (signal (car err) (cdr err))))))
    ad-do-it))


(defsubst elisp-info/search-prev-reference (start end)
  (goto-char end)
  (and (re-search-backward elisp-info-entry-regexp start t)
       (goto-char (match-beginning elisp-info-entry-regexp-pos))))


(defadvice Info-prev-reference
  (around elisp-info-prev-reference disable)
  (if (elisp-info/active-p)
      (let ((start (point)))
	(condition-case err
	    (let (end)
	      ad-do-it
	      (setq end (point))
	      (goto-char
	       (or (if (< end start)
		       (elisp-info/search-prev-reference end start)
		     (or (elisp-info/search-prev-reference (point-min) start)
			 (elisp-info/search-prev-reference end (point-max))))
		   end)))
	  (error
	   (if (string= (error-message-string err)
			"No cross references in this node")
	       (goto-char
		(or (elisp-info/search-prev-reference (point-min) start)
		    (elisp-info/search-prev-reference start (point-max))
		    start)))
	   (if (eq (point) start)
	       (signal (car err) (cdr err))))))
    ad-do-it))


(defun elisp-info/find-function (function)
  (elisp-info/split-window
   (find-function function)))


(defun elisp-info/find-variable (variable)
  (elisp-info/split-window
   (find-variable variable)))


(defadvice Info-follow-nearest-node
  (around elisp-info-follow-nearest-node disable)
  (or (if (elisp-info/active-p)
	  (save-excursion
	    (forward-line 0)
	    (if (looking-at elisp-info-entry-regexp)
		(let ((s (intern-soft (match-string-no-properties
				       elisp-info-entry-regexp-pos))))
		  (if s
		      (if (string-match elisp-info-variable-regexp
					(match-string 1))
			  (if (boundp s) (elisp-info/find-variable s))
			(if (fboundp s) (elisp-info/find-function s))))
		  t))))
      ad-do-it))


(defsubst elisp-info/assoc (key alist)
  ;; ʸ/ʸ̵뤷פԤ assoc.
  (setq key (downcase key))
  (while (and alist
	      (not (string= key (downcase (car (car alist))))))
    (setq alist (cdr alist)))
  (car alist))


(defadvice Info-follow-reference
  (around elisp-info-follow-reference disable)
  (interactive
   (let ((completion-ignore-case t)
	 (case-fold-search t)
	 completions functions variables
	 default alt-default (start-point (point)) str bol eol)
     (save-excursion
       (end-of-line)
       (setq eol (point))
       (forward-line 0)
       (setq bol (point))
       (goto-char (point-min))
       (while (re-search-forward "\\*note[ \n\t]*\\([^:]*\\):" nil t)
	 (setq str (match-string-no-properties 1))
	 (and (null default)
	      (<= (match-beginning 0) start-point)
	      (<= start-point (point))
	      (setq default t))
	 (and (null alt-default)
	      (<= bol (match-beginning 0))
	      (<= (point) eol)
	      (setq alt-default t))
	 (setq str (mapconcat 'identity (split-string str "[ \n\t]+") " "))
	 (if (eq default t) (setq default str))
	 (if (eq alt-default t) (setq alt-default str))
	 (or (elisp-info/assoc str completions)
	     (setq completions
		   (cons (cons str str) completions))))
       ;; Search references for functions and variables.
       (if (elisp-info/active-p)
	   (progn
	     (goto-char (point-min))
	     (while (re-search-forward elisp-info-entry-regexp nil t)
	       (setq str (match-string-no-properties
			  elisp-info-entry-regexp-pos))
	       (let ((symbol (intern-soft str))
		     (is-var (string-match elisp-info-variable-regexp
					   (match-string 1))))
		 (and symbol
		      (if is-var
			  (boundp symbol)
			(fboundp symbol))
		      (progn
			(and (null default)
			     (<= (match-beginning 0) start-point)
			     (<= start-point (point))
			     (setq default t))
			(and (null alt-default)
			     (<= bol (match-beginning 0))
			     (<= (point) eol)
			     (setq alt-default t))
			(or (if (elisp-info/assoc str completions)
				(elisp-info/assoc
				 (setq str
				       (concat str (if is-var "<v>" "<f>")))
				 completions))
			    (setq completions
				  (cons (cons str (cons symbol is-var))
					completions)))
			(if (eq default t) (setq default str))
			(if (eq alt-default t) (setq alt-default str)))))))))
     (or default (setq default alt-default))
     (if (eq (length completions) 1)
	 (setq default (car (car completions))))
     (if completions
	 (let ((input (completing-read
		       (if default
			   (concat "Follow reference named: ("
				   default ") ")
			 "Follow reference named: ")
		       completions nil t)))
	   (list (cdr (elisp-info/assoc (if (equal input "") default input)
					completions))))
       (error "No cross-references in this node"))))
  (if (and (elisp-info/active-p)
	   (consp (ad-get-arg 0)))
      (progn
	(if (cdr (ad-get-arg 0))
	    (elisp-info/find-variable (car (ad-get-arg 0)))
	  (elisp-info/find-function (car (ad-get-arg 0)))))
    ad-do-it))


(defadvice Info-set-mode-line
  (around elisp-info-set-mode-line disable)
  (if elisp-info/buffer-local-identifier
      (setq mode-line-buffer-identification
	    (format "  %s: (%s)%s"
		    elisp-info/buffer-local-identifier
		    (if Info-current-file
			(file-name-nondirectory Info-current-file)
		      "")
		    (or Info-current-node "")))
    ad-do-it))


(defadvice Info-fontify-node
  (around elisp-info-fontify-node disable)
  (let ((buffer-read-only nil)
	(font-lock-keywords elisp-info-font-lock-keywords))
    (font-lock-default-unfontify-region (point-min) (point-max))
    ad-do-it
    (font-lock-fontify-keywords-region (point-min) (point-max) nil)))


(defun elisp-info-setup-advices ()
  (interactive)
  (if (featurep 'advice)
      (let ((alist elisp-info/advice-alist))
	(while alist
	  (let ((func (if (eval (car (car alist)))
			  'ad-enable-advice
			'ad-disable-advice))
		(class (nth 1 (car alist)))
		(entries (nth 2 (car alist))))
	    (while entries
	      (funcall func (car (car entries)) class (cdr (car entries)))
	      (ad-activate (car (car entries)))
	      (setq entries (cdr entries))))
	  (setq alist (cdr alist))))))

;; Activate all advices.
(elisp-info-setup-advices)



;;;------------------------------------------------------------
;;;	ؿ/ѿ Info δط륳ޥ
;;;------------------------------------------------------------

(defun elisp-info-make-index () "\
Command to write list of functions and variables documented in elisp-jp to file.
Emacs-Lisp Reference Manual ڤ Mule-jp ǵҤƤؿѿ
Info  node Ȥбطκե( elisp-info-index.el )륳
ޥɡ

Non-interactive ˼¹Ԥ줿ϥȥǥ쥯ȥ˺롥
Interactive ˼¹Ԥ줿ϡelisp-info-index.el ޤ
elisp-info.el Τǥ쥯ȥ˺Ȥ뤬ե뤬ξȤ⸫
Ĥʤäϥ桼Ϥ롥
"
  (interactive)
  (elisp-info-make-index-file
   "elisp-info" (if noninteractive default-directory) nil t))


(defun elisp-info-make-index-file
  (identifier &optional directory require-regexp use-symbol) "\
Command to write list of functions and variables documented in info to file.
ؿѿ Info  node Ȥбطκեؿ
"
  (require 'info)
  (let* ((info-list (symbol-value (or (intern-soft (format "%s-list" identifier))
				      (error "Can't find variable: %s-list" identifier))))
	 (functions (intern (format "%s-function-alist" identifier)))
	 (variables (intern (format "%s-variable-alist" identifier)))
	 basename filename)
    ;; ե¸ǥ쥯ȥꤹ
    (if directory
	;; ˤäƻꤵƤϡ̵ˤѤ
	(setq basename (format "%s-index.el" identifier)
	      filename (expand-file-name basename directory))
      ;; (1) "identifier"-index-file Ȥѿ¸ߤϤ
      ;;     ͥ褷Ѥ롥
      ;; (2) "identifier"-index.el / "identifier".el ¸ߤǥ
      ;;     ȥõ
      (let* ((val (intern-soft (concat identifier "-index-file"))))
	(if (setq filename
		  (if (stringp (setq val (and val (boundp val) (symbol-value val))))
		      val
		    (elisp-info-get-index-file identifier)))
	    (setq basename (file-name-nondirectory filename)
		  directory (file-name-directory filename))
	  ;; ǤǤʤäϡ桼Ϥ
	  (setq basename (format "%s-index.el" identifier)
		directory (completing-read
			   (format "%s ֤ǥ쥯ȥꤷƲ: " basename)
			   'elisp-info-directory-completion nil 0)
		filename (expand-file-name basename directory)))))
    ;; Info 򸡺ƴؿ̾ڤѿ̾Ϣ
    (let (func-matches func-index-matches var-matches var-index-matches)
      (mapcar
       (lambda (info)
	 (let ((file-list
		(directory-files
		 (catch 'found
		   ;; ꤵ줿 Info Τǥ쥯ȥõ
		   (mapcar
		    (lambda (dir)
		      (if (or (file-readable-p (expand-file-name info dir))
			      (file-readable-p (expand-file-name (concat info ".gz") dir)))
			  (throw 'found dir)))
		    (append Info-directory-list Info-additional-directory-list))
		   (error "Can't find file: %s" info))
		 t (format "%s\\(-[0-9]+\\)?\\(\\.gz\\)?$" (regexp-quote info))))
	       (buffer (generate-new-buffer " *elisp-info*")))
	   (unwind-protect
	       (save-excursion
		 (set-buffer buffer)
		 (while file-list
		   ;; Info θġΥեɤ߹
		   (message "Reading %s ..." (car file-list))
		   (if (string-match "\\.gz$" (car file-list))
		       (if (= 0 (call-process "gzip" nil t nil "-dc" (car file-list)))
			   (goto-char (point-min))
			 (error "Can't extract file: %s" (car file-list)))
		     (insert-file-contents (car file-list)))
		   (setq file-list (cdr file-list))
		   ;; Node: ñ̤ǽԤʤ
		   (let ((case-fold-search t)
			 (start)
			 (node))
		     (while (re-search-forward (format elisp-info-node-regexp info) nil t)
		       (setq start (+ (match-beginning 0) 2)
			     node (match-string 1))
		       (narrow-to-region start
					 (if (search-forward "\n\^_" nil t)
					     (- (point) 2)
					   (point-max)))
		       (goto-char start)
		       (cond
			;; ؿκ
			((string= node "Function Index")
			 (while (re-search-forward elisp-info-index-regexp nil t)
			   (setq func-index-matches
				 (cons (list
					(match-string 1)
					(format "\(%s\)%s" info (match-string 2))
					(string-to-number (match-string 3)))
				       func-index-matches))))
			;; ѿκ
			((string= node "Variable Index")
			 (while (re-search-forward elisp-info-index-regexp nil t)
			   (setq var-index-matches
				 (cons (list
					(match-string 1)
					(format "\(%s\)%s" info (match-string 2))
					(string-to-number (match-string 3)))
				       var-index-matches))))
			(t ;; ؿ(ѿ)ʸ򸡺
			 (while (re-search-forward elisp-info-entry-regexp nil t)
			   (let ((item (match-string elisp-info-entry-regexp-pos)))
			     (if (string-match elisp-info-variable-regexp (match-string 1))
				 (setq var-matches
				       (cons (list
					      item
					      (format "\(%s\)%s" info node)
					      (1- (count-lines start (point))))
					     var-matches))
			       (setq func-matches
				     (cons (list
					    item
					    (format "\(%s\)%s" info node)
					    (1- (count-lines start (point))))
					   func-matches)))))))
		       (goto-char (point-max))
		       (widen)))
		   (erase-buffer)))
	     (kill-buffer buffer))))
       info-list)
      (set functions (elisp-info/make-alist func-matches func-index-matches use-symbol))
      (set variables (elisp-info/make-alist var-matches var-index-matches use-symbol)))
    ;; ե
    (let ((buffer (generate-new-buffer " *elisp-info*")))
      (unwind-protect
	  (save-excursion
	    (set-buffer buffer)
	    (insert ";;; -*- mode: Emacs-Lisp; coding: "
		    (prin1-to-string
		     (elisp-info/static-if
			 (and (boundp 'emacs-major-version)
			      (>= emacs-major-version 20))
			 buffer-file-coding-system
		       file-coding-system))
		    "; -*-\n;; This is the index file\n"
		    ";; generated by elisp-info-make-index-file on "
		    (current-time-string)
		    ".\n\n"
		    (format "\(provide '%s\)" (substring basename 0 -3))
		    "\n\n")
	    (mapcar (lambda (sym)
		      (insert "\(setq "
			      (symbol-name sym)
			      "\n      '\("
			      (mapconcat 'prin1-to-string
					 (symbol-value sym)
					 "\n        ")
			      "\)\)\n"))
		    (list functions variables))
	    ;; ؿ̾ / ѿ̾ɽɬפʾ
	    (if require-regexp
		(let (name value)
		  (mapcar
		   (lambda (sym)
		     (setq name  (concat (substring (symbol-name sym) 0 -6) "-regexp")
			   value (format "\\b\\(%s\\)\\b"
					 (if (fboundp 'regexp-opt)
					     (regexp-opt
					      (mapcar 'car (symbol-value sym)))
					   (mapconcat
					    (lambda (item)
					      (regexp-quote (car item)))
					    (symbol-value sym)
					    "\\|"))))
		     (set (intern name) value)
		     (insert (format "\(setq %s %s\)\n" name (prin1-to-string value))))
		   (list functions variables))))
	    (if (file-writable-p filename)
		(if (get-file-buffer filename)
		    (error "%s is locked. Can't overwrite." filename)
		  (message "Writing %s ..." filename)
		  (write-region (point-min) (point-max) filename)
		  (message "")
		  filename)
	      (error "%s is write-protected." filename)))
	(kill-buffer buffer)))))


(defun elisp-info/make-alist (matches index-matches use-symbol)
  (let (alist)
    (setq matches
	  (delq t
		(mapcar
		 (lambda (entry)
		   (or (string= "" (car entry))
		       entry))
		 (nconc
		  (reverse matches)
		  (reverse
		   (mapcar 
		    (lambda (entry)
		      (cons
		       (if (string-match elisp-info-index-suffix-regexp
					 (car entry))
			   (substring (car entry) 0 (match-beginning 0))
			 (car entry))
		       (cdr entry)))
		    index-matches))))))
    (if use-symbol
	(setq matches
	      (mapcar (lambda (entry)
			(cons (intern (car entry)) (cdr entry)))
		      matches)))
    (while matches
      (let* ((item (car (car matches)))
	     (node (nth 1 (car matches)))
	     (line (nth 2 (car matches)))
	     (entry (assoc item alist)))
	(if entry
	    (or (member node entry)
		(setcdr entry (nconc (cdr entry) (list node line))))
	  (setq alist (cons (list item node line) alist))))
      (setq matches (cdr matches)))
    (sort (nreverse alist)
	  (lambda (a b) (string< (car a) (car b))))))


;;; ǥ쥯ȥ̾䴰դϤ뤿Υץ䴰ؿ
(defun elisp-info-directory-completion (dir predicate flag)
  "Completion function for directory"
  (if (eq flag 'lambda)
      (and (string= "/" (substring dir -1))
	   (file-directory-p dir))
    (let (alist)
      (setq dir (expand-file-name dir))
      (mapcar (lambda (f)
		(and (not (string-match "/\\.\\.?$" f))
		     (file-directory-p f)
		     (setq alist (cons (cons (concat f "/") 0) alist))))
	      (directory-files (file-name-directory dir) t))
      (cond
       ((eq flag nil) (try-completion dir alist predicate))
       ((eq flag t) (all-completions dir alist predicate)))
      )))



;;;----------------------------------------------------------------------
;;;		Ƽ Emacsen ΰ㤤ۼؿ
;;;----------------------------------------------------------------------

(or (fboundp 'match-string)
    ;; imported from emacs-19.34/lisp/subr.el.
    (defun match-string (num &optional string)
      "Return string of text matched by last search.
NUM specifies which parenthesized expression in the last regexp.
 Value is nil if NUMth pair didn't match, or there were less than NUM pairs.
Zero means the entire text matched by the whole regexp or whole string.
STRING should be given if the last search was by `string-match' on STRING."
      (if (match-beginning num)
	  (if string
	      (substring string (match-beginning num) (match-end num))
	    (buffer-substring (match-beginning num) (match-end num))))))


(or (fboundp 'match-string-no-properties)
    ;; imported from emacs-20.7/lisp/subr.el.
    (defun match-string-no-properties (num &optional string)
      "Return string of text matched by last search, without text properties.
NUM specifies which parenthesized expression in the last regexp.
 Value is nil if NUMth pair didn't match, or there were less than NUM pairs.
Zero means the entire text matched by the whole regexp or whole string.
STRING should be given if the last search was by `string-match' on STRING."
      (if (match-beginning num)
	  (if string
	      (let ((result
		     (substring string (match-beginning num) (match-end num))))
		(set-text-properties 0 (length result) nil result)
		result)
	    (buffer-substring-no-properties (match-beginning num) (match-end num))))))


(or (fboundp 'split-string)
    (defun split-string (string &optional pattern)
      "Return a list of substrings of STRING which are separated by PATTERN.
If PATTERN is omitted, it defaults to \"[ \\f\\t\\n\\r\\v]+\"."
      (or pattern
	  (setq pattern "[ \f\t\n\r\v]+"))
      (let (parts (start 0))
	(while (string-match pattern string start)
	  (setq parts (cons (substring string start (match-beginning 0)) parts)
		start (match-end 0)))
	(nreverse (cons (substring string start) parts)))))



;;; elisp-info.el ends here.
